﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?VMArgs=-DZeroSharedFiles%3DTrue&File=%B4X%\Zipper.jar&Args=B4XTableExample.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private B4XTable1 As B4XTable
	Private xui As XUI
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me, "B4XTable Example")
	
	'create the columns
	Dim c1 As B4XTableColumn = B4XTable1.AddColumn("Header", B4XTable1.COLUMN_TYPE_TEXT)
	c1.Width = 100dip
	c1.id = 0
	'
	Dim c2 As B4XTableColumn = B4XTable1.AddColumn("Col1", B4XTable1.COLUMN_TYPE_TEXT)
	c2.id = 1
	'
	Dim c3 As B4XTableColumn = B4XTable1.AddColumn("Col2", B4XTable1.COLUMN_TYPE_TEXT)
	c3.id = 2
	'
	Dim c4 As B4XTableColumn = B4XTable1.AddColumn("Col3", B4XTable1.COLUMN_TYPE_TEXT)
	c4.id = 3
	'
	' load some data in columns
	Dim data As List
	data.Initialize
	For i = 1 To 9
		data.Add(Array("Header", "text col 1", "text col 2", "text col 3"))
	Next
	
	B4XTable1.VisibleColumns.Clear
	B4XTable1.VisibleColumns.AddAll(Array(c1, c2, c3, c4))
    '
	Wait For (B4XTable1.SetData(data)) Complete (Unused As Boolean)
	'
	B4XTable1.NumberOfFrozenColumns = 1


	' how to show just "Header" and "Col3" columns with no horizontal scroll ?
'	Dim indexTo As String = 1  			' indexTo=1 shows Col1 
	Dim indexTo As String = 2  			' indexTo=2 shows Col2
 
'	Dim indexTo As String = 3  			' indexTo=3 generates error  <<<
	' log :
	' b4xtable_resizeandreorderclvitems (java line: 2248)
	' java.lang.RuntimeException: Object should first be initialized (View).
	' Did you forget to call Activity.LoadLayout?
	' 	at anywheresoftware.b4a.AbsObjectWrapper.getObject(AbsObjectWrapper.java:67)
	' 	at anywheresoftware.b4a.objects.B4XViewWrapper.GetView(B4XViewWrapper.java:318)
	' 	at b4a.example3.customlistview._getpanel(customlistview.java:440)
	' ...

	showJustOne(B4XTable1, indexTo)

End Sub

Sub B4XTable1_DataUpdated
	
End Sub

Sub B4XTable1_CellClicked (ColumnId As String, RowId As Long)

End Sub

'Sub IME_HeightChanged (NewHeight As Int, OldHeight As Int)
'	If B4XTable1.IsInitialized Then
'		B4XTable1.mBase.Height = NewHeight - B4XTable1.mBase.Top
'		B4XTable1.Refresh
'	End If
'End Sub

Sub showJustOne(tbl As B4XTable, colid As String)
	For i = 1 To 3
		HideColumn(tbl, i)			' hide columns 2 ,3 and 4
	Next
	showColAtOne(tbl, colid)
End Sub

Sub showColAtOne(tbl As B4XTable, ColumnId As String)
	Dim column As B4XTableColumn = tbl.GetColumn(ColumnId)
	tbl.VisibleColumns.InsertAt(1, column)
	tbl.Refresh
End Sub

Public Sub HideColumn(tbl As B4XTable, ColID As String)
	Dim poCol As B4XTableColumn = tbl.GetColumn(ColID)
	If poCol <> Null And poCol.IsInitialized Then
		Dim piVisibleColIndex As Int = tbl.VisibleColumns.IndexOf(poCol)
		If piVisibleColIndex >= 0 Then
			tbl.VisibleColumns.RemoveAt(piVisibleColIndex) 'hide column
			If tbl.clvData.IsInitialized Then
				If tbl.clvData.Size > piVisibleColIndex Then
					tbl.clvData.RemoveAt(piVisibleColIndex)
				End If
			End If
			poCol.Panel.RemoveViewFromParent
		End If
		tbl.Refresh
	End If
End Sub

